// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
#include <time.h>
using namespace std;

bool f(bool bm, bool b, bool bp){ return (bm&&!bp)||(!bm&&bp); }
int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
    myofs << "Team 123,   . 18  2008 ." << endl; 
    myofs << "  3-12.  new  delete" << endl << endl; 
  }
  {
    myofs << " 1a.   ,  new." << endl;
    const int N=15; int wd=2; // wd       
    int* nn = new int[N];
    if(!nn){myofs << "   " << endl;}
    else{
      myofs << "  new      ,  " << nn << endl;
      for(int n=0; n<N; n++) nn[n]=n%3 + n%4 + n%5 + n%6;
      myofs << "  nn[N]        ," << endl;
      for(int n=0; n<N; n++){
        myofs << "  nn[" << setw(wd) << n << "]=" << setw(4) << nn[n];
        if((n+1)%5==0) myofs << endl;
      }
      myofs << endl;
      myofs << "  <<      ." << endl;
      myofs << "    nn=" << nn << endl;
      myofs << "  <<          . " << endl; 
      myofs << "    *nn=" << *nn << endl;
      myofs << "    *(nn+1)=" << *(nn+1) << endl;
      myofs << "    *(nn+N-1)=" << *(nn+N-1) << endl << endl;
      if(nn){ delete[]nn; nn=NULL; }
    }
  }
  {
    myofs << " 1b.    new." << endl;
    myofs << "    unhandled exception   N=20*1000*1000  N=200*1000*1000." << endl;
    const int N=20*1000*1000;
    int *nn1=NULL, *nn2=NULL, *nn3=NULL, *nn4=NULL, *nn5=NULL;
    nn1 = new int[N]; if(!nn1)goto next;
    myofs << "  new   nn1=" << nn1 << endl;
    nn2 = new int[N]; if(!nn2)goto next;
    myofs << "  new   nn2=" << nn2 << endl;
    nn3 = new int[N]; if(!nn3)goto next;
    myofs << "  new   nn3=" << nn3 << endl;
    nn4 = new int[N]; if(!nn4)goto next;
    myofs << "  new   nn4=" << nn4 << endl;
    nn5 = new int[N]; if(!nn5)goto next;
    myofs << "  new   nn5=" << nn5 << endl;
    next:
    if(nn1 || nn2 || nn3 || nn4 || nn5){
      for(int n=0; n<100; n++) nn1[n]=n%3 + n%4 + n%5 + n%6;
      myofs << "  nn[N]        ," << N << endl;
      for(int n=0; n<100; n++){
        myofs << "  nn[" << setw(3) << n << "]=" << setw(4) << nn1[n];
        if((n+1)%5==0) myofs << endl;
      }
    }
    else
    {
      myofs << "     .    ." << endl;
      myofs << "    ." << endl;
    }
    if(nn1){ delete[]nn1; nn1=NULL; }
    if(nn2){ delete[]nn2; nn2=NULL; }
    if(nn3){ delete[]nn3; nn3=NULL; }
    if(nn4){ delete[]nn4; nn4=NULL; }
    if(nn5){ delete[]nn5; nn5=NULL; }
  }
  {
    myofs << " 2.   , ." << endl;
    const int N=2000; //  
    const int J=128; //  
    int wd=2, m;
    int* nn = new int[N];
    if(!nn){myofs << "   " << endl; goto fin;}
    int* his = new int[J]; 
    if(!his){myofs << "   " << endl; goto fin;}
    srand((unsigned)time(NULL)); //  rand();
    for(int n=0; n<N; n++) nn[n]=rand()%J;
    for(int j=0; j<J; j++) his[j]=0;
    for(int n=0; n<N; n++){ //  :
      m=nn[n]; 
      if(m<0)m=0;
      if(m>J-1)m=J-1;
      his[m]+=1; 
    }
    char ch[J+1]; //    :
    int K=0;
    for(int j=0; j<J; j++) 
      if(his[j]>K)K=his[j];
    for(int k=K; k>=0; k--){
      for(int j=0; j<J; j++){
        ch[j]=' ';
        if(his[j]>k)ch[j]='x';
      }
      ch[J]='\0';
      myofs << setw(3) << k << " " << ch << endl;
    }
    for(int j=0; j<J+4; j+=4) 
      myofs << setw(4) << j;
    myofs << endl << endl;
    delete[] nn;
    delete[] his;
    fin: ;
  }
  {
    myofs << " 3.    life" << endl;
    const int N=128; //  
    bool* bb = new bool[N], *bb1 = new bool[N];
    char* ch = new char[N+1];
    if(!bb||!bb1||!ch){myofs << "   " << endl; goto fin3;}
    char smb[] = {' ', 'x'};
    for(int n=0; n<N; n++){
      int k=0;
      for(int j=0; j<16; j++)
        k+=rand()%2;
      bb[n]=k>11;
    }
    for(int m=0; m<200; m++){
      bb1[0]=f(false, bb[0], bb[1]); // f   ;
      bb1[N-1]=f(bb[N-2], bb[N-1], false);
      for(int n=1; n<N-1; n++)
        bb1[n]=f(bb[n-1], bb[n], bb[n+1]);
      for(int n=0; n<N; n++){
        bb[n]=bb1[n];
        ch[n]=smb[int(bb[n])];
      }
      ch[N]='\0';
      myofs << ch << endl;
    }
    myofs << endl;
    delete[] bb;
    delete[] bb1;
    delete[] ch;
    fin3: ;
  }
  {
    myofs << " 4.   double,  new." << endl;
    const int M=128; int wd=2;
    double* xx=new double[M];
    double* yy=new double[M];
    if(!xx||!yy){myofs << "   " << endl; goto fin4;}
    for(int m=0; m<M; m++){ 
      xx[m]=2*3.1415926*double(m)/double(M);
      yy[m]=cos(xx[m]);
    }
    myofs << " yy[...]        ," << endl;
    for(int m=0; m<M; m++){
      myofs << "  yy[" << setw(wd) << m << "]=" << setw(6) << setprecision(2) << yy[m];
      if((m+1)%8==0) myofs << endl;
    }
    myofs << " 5.      " << endl;
    myofs << "     x,    y" << endl;
    double d1=yy[0], d2=yy[0];
    int k; 
    const int J=128;
    for(int m=0; m<M; m++){
      if(yy[m]<d1) d1=yy[m];
      if(yy[m]>d2) d2=yy[m];
    }
    myofs << "      "; for(int j=0; j<J+3; j++) myofs << "-"; myofs << endl;
    for(int m=0; m<M; m++){
      k=floor(double(J)*(yy[m]-d1)/(d2-d1));
      myofs << setw(5) << setprecision(2) << xx[m] << " |";
      for(int j=0; j<k; j++) myofs << " ";
      myofs << "x";
      for(int j=0; j<J-k; j++) myofs << " ";
      myofs << "|" << endl;
    }
    myofs << "      "; for(int j=0; j<J+3; j++) myofs << "-"; myofs << endl;
    myofs << endl;
    myofs << " 6.      " << endl;
    myofs << "     y,    x" << endl;
    char ch[M+1];
    myofs << "      "; 
    for(int m=0; m<M+3; m++) myofs << "-"; myofs << endl;
    for(int j=J-1; j>=0; j--){
      if(j%3!=0)continue;
      myofs << setw(2) << j << setw(6) << setprecision(2) << d1+j*(d2-d1)/J;
      for(int m=0; m<M; m++){
        k=ceil(double(J)*(yy[m]-d1)/(d2-d1));
        ch[m]=' '; 
        if(k==j||k==j+1||k==j+2||k==j-1) ch[m]='x';
      }
      ch[M]='\0';
      myofs << ch << endl;
    }
    myofs << "      "; 
    for(int m=0; m<J+3; m++) myofs << "-"; myofs << endl;
    myofs << endl;
    delete[] xx;
    delete[] yy;
    fin4: ;
  }
  {
    myofs << " 7.   " << endl;
    const int N=32;
    double** pp = new double*[N];
    if(!pp){myofs << "   " << endl; goto fin7;}
    myofs << "  pp=" << pp << ",      :" << endl;
    for(int n=0; n<N; n++){
      myofs << " [" << setw(2) << n << "]=" << pp[n];  
      if(n%5==4) myofs << endl;
    } myofs << endl;
    for(int n=0; n<N; n++) pp[n]=new double;
    myofs << "  *pp=" << *pp << ",      :" << endl;
    for(int n=0; n<N; n++){
      myofs << " [" << setw(2) << n << "]=" << pp[n];  
      if(n%5==4) myofs << endl;
    } myofs << endl;
    for(int n=0; n<N; n++) *pp[n]=sin(3.1415926*0.16666666*0.5*n);
    myofs << "  **pp=" << **pp << ",      :" << endl;
    for(int n=0; n<N; n++){
      myofs << " [" << setw(2) << n << "]=" << setw(8) << setprecision(4) << *pp[n];  
      if(n%6==5) myofs << endl;
    }
    for(int n=0; n<N; n++) delete pp[n];
    delete pp;
    fin7: ;
  }
  myofs.close();
  return 0;
}

